extends TextureRect

#signals that thos node may emit
signal swipe(swipe_type)
signal doubleTap()

#for calculating swipe
var swipe_start;
var swipe_type = 0; #-1,1 for horizontal. -2,2 for vertical

#for calculating double tap
const COMBO_TIMEOUT = 1 # Timeout between key presses
const MAX_COMBO_CHAIN = 2 # Maximum key presses in a combo
var last_key_delta = 0    # Time since last keypress
var key_combo = []        # Current combo

# Called when the node enters the scene tree for the first time.
func _ready():
	pass # Replace with function body.

func _calculate_swipe(position):
	if(abs(position.y - swipe_start.y) < 10 && abs(position.x - swipe_start.x) < 10):
		swipe_type = 0;
		return;
			
	if(abs(position.y - swipe_start.y) > abs(position.x - swipe_start.x)):
		if(position.y < swipe_start.y):
			swipe_type = 2; #vertical down
		else:
			swipe_type = -2; #vertical up
	else:
		if(position.x > swipe_start.x):
			swipe_type = 1; #horizontal left
		else:
			swipe_type = -1; #horizontal right
	
	print(swipe_type);
	self.emit_signal("swipe", swipe_type);
		
func _process(delta):
	last_key_delta += delta                                      # Track time between keypresses

func _on_texture_rect_gui_input(event):
	if event is InputEventScreenTouch:
		print(event);
		
	#try to detect swipe
	if event is InputEventScreenTouch and event.pressed:
		swipe_start = event.position
	if event is InputEventScreenTouch and not event.pressed:
		_calculate_swipe(event.position)
		
	#try to detect double tap
	if event is InputEventScreenTouch and event.pressed: # If distinct key press down
		print("pressed once");
		print(last_key_delta)
		if last_key_delta > COMBO_TIMEOUT:                   # Reset combo if stale
			key_combo = []
			print("touch timeout, reset combo");
			
		key_combo.append(1)                     # Otherwise add it to combo
		if key_combo.size() > MAX_COMBO_CHAIN:               # Prune if necessary
			key_combo.pop_front()
			print("max combo size reached, popping one");
		
		if(key_combo.size() == MAX_COMBO_CHAIN):  
			key_combo = []                                   # Log the combo (could pass to combo evaluator)
			print("emitting doubletap event from TextureRect");
			
			#Global.doubleTapConsumed = false;
			self.emit_signal("doubleTap");                               # Reset keypress timer
 
		last_key_delta = 0
		
